#ifndef AMPAPP_H
#define AMPAPP_H

#include <memory>
#include <QApplication>
#include <QCommandLineParser>
#include <QItemSelectionModel>
#include <QObject>

#include <datasource/datasourceinterface.h>

class AMPAppPrivate;

class AMPApp : public QObject
{
public:
    Q_OBJECT

public:
    AMPApp(QApplication *app, DataSourceInterface *source, QObject *parent = nullptr);
    ~AMPApp();

    int runApp();

private:
    void buildModel();
    void chooseController(QString interface);

private slots:
    void onManagerChanged(const QItemSelection &newSelection, const QItemSelection &previousSelection);

private:
    std::unique_ptr<AMPAppPrivate> d;

public:
    AMPApp(const AMPAppPrivate &) = delete;
    AMPApp(AMPAppPrivate &&)      = delete;
    AMPApp &operator=(const AMPAppPrivate &) = delete;
    AMPApp &operator=(AMPAppPrivate &&) = delete;
};

#endif // AMPAPP_H
