#ifndef AMPPARSER_H
#define AMPPARSER_H

#include <QApplication>

struct CommandLineOptions
{
public:
    QString objectName{};
};

class AMPParserPrivate;

class AMPParser
{
public:
    enum AMPParseResult
    {
        CommandLineOk,
        CommandLineError,
        CommandLineVersionRequested,
        CommandLineHelpRequested,
        CommandLineObjectRequested
    };

public:
    AMPParser(QApplication &application);
    ~AMPParser();

    AMPParseResult parseCommandLine(CommandLineOptions *options, QString *errorMessage);

    void showHelp();
    void showVersion();

private:
    AMPParser(const AMPParser &) = delete;
    AMPParser(AMPParser &&)      = delete;
    AMPParser &operator=(const AMPParser &) = delete;
    AMPParser &operator=(AMPParser &&) = delete;

private:
    AMPParserPrivate *d;
};

#endif // AMPPARSER_H
