#include "ampproxymodel.h"

AMPProxyModel::AMPProxyModel(std::vector<int> columns, QObject *parent)
    : super(parent)
{
    for (auto col : columns)
    {
        m_columns.insert(col);
    }
}

QVariant AMPProxyModel::getEntity(int row)
{
    return getEntity(index(row, 0));
}

QVariant AMPProxyModel::getEntity(const QModelIndex &index)
{
    return mapToSource(index).siblingAtColumn(sourceModel()->columnCount() - 1).data();
}

bool AMPProxyModel::filterAcceptsColumn(int source_column, const QModelIndex &source_parent) const
{
    if ((m_columns.find(source_column) != m_columns.end() || m_columns.empty())
        && source_column != sourceModel()->columnCount() - 1)
    {
        return true;
    }
    else
    {
        return false;
    }
}
