#include "aptbuttonswidget.h"
#include "ui_aptbuttonswidget.h"

AptButtonsWidget::AptButtonsWidget(AptController *controller, QWidget *parent)
    : QWidget(parent)
    , ui(new Ui::AptButtonsWidget)
    , m_controller(controller)
{
    ui->setupUi(this);

    QSizePolicy sp_retain = ui->updateProgressBar->sizePolicy();
    sp_retain.setRetainSizeWhenHidden(true);
    ui->updateProgressBar->setSizePolicy(sp_retain);
    ui->updateProgressBar->hide();

    connect(ui->applyButton, &QPushButton::clicked, this, &AptButtonsWidget::onApplyButtonClicked);
    connect(ui->updatePushButton, &QPushButton::clicked, this, &AptButtonsWidget::onUpdateButtonClicked);
}

AptButtonsWidget::~AptButtonsWidget()
{
    delete ui;
}

void AptButtonsWidget::disableButtons()
{
    ui->applyButton->setEnabled(false);
    ui->updatePushButton->setEnabled(false);
}

void AptButtonsWidget::enableButtons()
{
    ui->applyButton->setEnabled(true);
    ui->updatePushButton->setEnabled(true);
}

void AptButtonsWidget::setProgress(int status)
{
    ui->updateProgressBar->show();
    ui->updateProgressBar->setValue(status);
}

void AptButtonsWidget::hideProgress()
{
    ui->updateProgressBar->hide();
}

void AptButtonsWidget::onApplyButtonClicked()
{
    m_controller->onApplyButtonPressed();
}

void AptButtonsWidget::onUpdateButtonClicked()
{
    m_controller->onUpdateButtonPressed();
}
