#ifndef APTBUTTONSWIDGET_H
#define APTBUTTONSWIDGET_H

#include "aptcontroller.h"

#include <QWidget>

namespace Ui
{
class AptButtonsWidget;
}

class AptButtonsWidget : public QWidget
{
    Q_OBJECT

public:
    explicit AptButtonsWidget(AptController *controller, QWidget *parent = nullptr);
    ~AptButtonsWidget();

    AptButtonsWidget(const AptButtonsWidget &) = delete;
    AptButtonsWidget(AptButtonsWidget &&)      = delete;

    AptButtonsWidget &operator=(const AptButtonsWidget &) = delete;
    AptButtonsWidget &operator=(AptButtonsWidget &&) = delete;

    void disableButtons();
    void enableButtons();

    void setProgress(int status);
    void hideProgress();

private slots:
    void onApplyButtonClicked();
    void onUpdateButtonClicked();

private:
    Ui::AptButtonsWidget *ui;

    AptController *m_controller;
};

#endif // APTBUTTONSWIDGET_H
