#ifndef APTCONTROLLER_H
#define APTCONTROLLER_H

#include "controllers/basecontroller.h"
#include "package.h"

class AptControllerPrivate;

class AptController : public QObject, public BaseController
{
    Q_OBJECT
public:
    AptController(DataSourceInterface *dataSource);
    ~AptController();

    QString getInterface() override;
    QString getPath() override;

    void selected() override;
    void deSelected() override;

    void onWindowClose() override;

    void update() override;

    void onFilterTextChanged(const QString text) override;

    void onApplyButtonPressed();
    void onUpdateButtonPressed();

    int onItemClicked(const Package &pkg);

public slots:
    void onAptUpdateFinished(QDBusPendingCallWatcher *call);

private:
    void disableButtons();
    void enableButtons();

    void updateModelData();

private:
    std::unique_ptr<AptControllerPrivate> d;

private:
    AptController(const AptController &) = delete;
    AptController(AptController &&)      = delete;
    AptController &operator=(const AptController &) = delete;
    AptController &operator=(AptController &&) = delete;
};

#endif // APTCONTROLLER_H
