#ifndef APTCONTROLLERWIDGET_H
#define APTCONTROLLERWIDGET_H

#include "ampproxymodel.h"
#include "aptcontroller.h"
#include "package.h"
#include "packagemodel.h"

#include <QWidget>

namespace Ui
{
class AptControllerWidget;
}

class AptControllerWidget : public QWidget
{
    Q_OBJECT

public:
    explicit AptControllerWidget(AptController *controller, QWidget *parent = nullptr);
    ~AptControllerWidget();

    AptControllerWidget(const AptControllerWidget &) = delete;
    AptControllerWidget(AptControllerWidget &&)      = delete;

    AptControllerWidget &operator=(const AptControllerWidget &) = delete;
    AptControllerWidget &operator=(AptControllerWidget &&) = delete;

    void setPackagesData(const std::vector<Package> &packages);

    void setFilter(const QString text);

private slots:
    void itemClicked(const QModelIndex &topLeft, const QModelIndex &bottomRight, const QVector<int> &roles);

private:
    Ui::AptControllerWidget *ui;

    AptController *m_controller;

    std::unique_ptr<PackageModel> model;
    std::unique_ptr<AMPProxyModel> proxyModel;

    const int columnCount    = 2;
    const int checkBoxColumn = 1;

    void paintRow(int row, QBrush brush);
};

#endif // APTCONTROLLERWIDGET_H
