#include "basecontroller.h"

class BaseControllerPrivate
{
public:
    BaseControllerPrivate(DataSourceInterface *dataSource)
        : m_mainWindow(nullptr)
        , m_dataSource(dataSource)
    {}

    MainWindowInterface *m_mainWindow;

    DataSourceInterface *m_dataSource;
};

BaseController::BaseController(DataSourceInterface *dataSource)
    : d(new BaseControllerPrivate(dataSource))
{}

BaseController::~BaseController() {}

QString BaseController::getInterface()
{
    return BASE_INTERFACE_NAME;
}

QString BaseController::getPath()
{
    return BASE_OBJECT_PATH;
}

void BaseController::selected() {}

void BaseController::deSelected() {}

void BaseController::onWindowClose() {}

void BaseController::update() {}

void BaseController::setWindow(MainWindowInterface *window)
{
    d->m_mainWindow = window;
}

MainWindowInterface *BaseController::getWindow()
{
    return d->m_mainWindow;
}

void BaseController::onFilterTextChanged(const QString text) {}

DataSourceInterface *BaseController::getDataSource()
{
    return d->m_dataSource;
}
