#ifndef BASECONTROLLER_H
#define BASECONTROLLER_H

#include "constants.h"
#include "controllerinterface.h"

#include "datasource/datasourceinterface.h"

class BaseControllerPrivate;

class BaseController : public ControllerInterface
{
public:
    BaseController(DataSourceInterface *dataSource);
    virtual ~BaseController();

public:
    QString getInterface() override;
    QString getPath() override;

    void selected() override;
    void deSelected() override;

    void onWindowClose() override;

    void update() override;

    void setWindow(MainWindowInterface *window) override;
    MainWindowInterface *getWindow() override;

    void onFilterTextChanged(const QString text) override;

protected:
    DataSourceInterface *getDataSource();

private:
    std::unique_ptr<BaseControllerPrivate> d;
};

#endif // BASECONTROLLER_H
