#ifndef CONTROLLERINTERFACE_H
#define CONTROLLERINTERFACE_H

#include <memory>
#include <QString>
#include <QWidget>

#include <mainwindow/mainwindowinterface.h>

class ControllerInterface
{
public:
    virtual ~ControllerInterface() = default;

    virtual QString getInterface() = 0;
    virtual QString getPath()      = 0;

    virtual void selected()   = 0;
    virtual void deSelected() = 0;

    virtual void onWindowClose() = 0;

    virtual void update() = 0;

    virtual void setWindow(MainWindowInterface *window) = 0;
    virtual MainWindowInterface *getWindow()            = 0;

    virtual void onFilterTextChanged(const QString text) = 0;
};

#endif //CONTROLLERINTERFACE_H
