#include "defaultcontroller.h"
#include "constants.h"
#include "defaultbuttonswidget.h"
#include "defaultcontrollerwidget.h"

class DefaultControllerPrivate
{
public:
    DefaultControllerPrivate(DefaultController *controller)
        : m_selected(false)
    {}

    ~DefaultControllerPrivate() {}

    bool m_selected;
};

DefaultController::DefaultController(DataSourceInterface *dataSource)
    : BaseController(dataSource)
    , d(new DefaultControllerPrivate(this))
{}

DefaultController::~DefaultController() {}

QString DefaultController::getInterface()
{
    return DEFAULT_INTERFACE_NAME;
}

QString DefaultController::getPath()
{
    return DEFAULT_OBJECT_PATH;
}

void DefaultController::selected()
{
    d->m_selected = true;

    DefaultButtonsWidget *buttonWidget        = new DefaultButtonsWidget(this);
    DefaultControllerWidget *controllerWidget = new DefaultControllerWidget();

    getWindow()->setButtonWidget(buttonWidget);

    getWindow()->setControllerWidget(controllerWidget);
}

void DefaultController::deSelected()
{
    d->m_selected = false;
}

void DefaultController::onWindowClose() {}
