#ifndef DEFAULTCONTROLLER_H
#define DEFAULTCONTROLLER_H

#include "controllers/basecontroller.h"

class DefaultControllerPrivate;

class DefaultController : public BaseController
{
public:
    DefaultController(DataSourceInterface *dataSource);
    ~DefaultController();

    QString getInterface() override;
    QString getPath() override;

    void selected() override;
    void deSelected() override;

    void onWindowClose() override;

private:
    std::unique_ptr<DefaultControllerPrivate> d;

private:
    DefaultController(const DefaultController &) = delete;
    DefaultController(DefaultController &&)      = delete;
    DefaultController &operator=(const DefaultController &) = delete;
    DefaultController &operator=(DefaultController &&) = delete;
};

#endif // DEFAULTCONTROLLER_H
