#include "loadcontroller.h"
#include "constants.h"
#include "loadbuttonswidget.h"
#include "loadcontrollerwidget.h"

class LoadControllerPrivate
{
public:
    LoadControllerPrivate(LoadController *controller)
        : m_selected(false)
    {}

    ~LoadControllerPrivate() {}

    bool m_selected;
};

LoadController::LoadController(DataSourceInterface *dataSource)
    : BaseController(dataSource)
    , d(new LoadControllerPrivate(this))
{}

LoadController::~LoadController() {}

QString LoadController::getInterface()
{
    return LOAD_INTERFACE_NAME;
}

QString LoadController::getPath()
{
    return LOAD_OBJECT_PATH;
}

void LoadController::selected()
{
    d->m_selected = true;

    LoadButtonsWidget *buttonWidget        = new LoadButtonsWidget(this);
    LoadControllerWidget *controllerWidget = new LoadControllerWidget();

    getWindow()->setButtonWidget(buttonWidget);

    getWindow()->setControllerWidget(controllerWidget);
}

void LoadController::deSelected()
{
    d->m_selected = false;
}

void LoadController::onWindowClose() {}

void LoadController::onExitButtonPressed()
{
    getWindow()->closeFromButtonWidget();
}
