#ifndef LOADCONTROLLER_H
#define LOADCONTROLLER_H

#include "controllers/basecontroller.h"

class LoadControllerPrivate;

class LoadController : public BaseController
{
public:
    LoadController(DataSourceInterface *dataSource);
    ~LoadController();

    QString getInterface() override;
    QString getPath() override;

    void selected() override;
    void deSelected() override;

    void onWindowClose() override;

    void onExitButtonPressed();

private:
    std::unique_ptr<LoadControllerPrivate> d;

private:
    LoadController(const LoadController &) = delete;
    LoadController(LoadController &&)      = delete;
    LoadController &operator=(const LoadController &) = delete;
    LoadController &operator=(LoadController &&) = delete;
};

#endif // LOADCONTROLLER_H
