#ifndef PACKAGE_H
#define PACKAGE_H

#include <QMetaType>
#include <QString>

struct Package
{
    QString m_name{};
    QString m_version{};
    QString m_release{};
    QString m_arch{};
    bool m_installed{false};

    Package(QString name, QString version, QString release, QString arch)
        : m_name(name)
        , m_version(version)
        , m_release(release)
        , m_arch(arch)
        , m_installed(false)
    {}

    Package(QString name, bool installed)
        : m_name(name)
        , m_version()
        , m_release()
        , m_arch()
        , m_installed(installed)
    {}

    Package()
        : m_name()
        , m_version()
        , m_release()
        , m_arch()
        , m_installed(false)
    {}
    ~Package() = default;

    Package(const Package &package)
        : m_name(package.m_name)
        , m_version(package.m_version)
        , m_release(package.m_release)
        , m_arch(package.m_arch)
        , m_installed(package.m_installed)
    {}

    Package &operator=(const Package &package)
    {
        this->m_name      = package.m_name;
        this->m_version   = package.m_version;
        this->m_release   = package.m_release;
        this->m_arch      = package.m_arch;
        this->m_installed = package.m_installed;
        return *this;
    }

    void clear()
    {
        m_name.clear();
        m_version.clear();
        m_release.clear();
        m_arch.clear();
    }
};

Q_DECLARE_METATYPE(Package)

#endif // PACKAGE_H
