#include "packagemodel.h"

PackageModel::PackageModel(int rows, QObject *parent)
{
    super(rows, structSize + 1, parent);
}

void PackageModel::appendRow(const QVariant &entity)
{
    QStandardItem *packageItem = new QStandardItem();
    packageItem->setData(entity, Qt::DisplayRole);
    Package package = entity.value<Package>();

    QStandardItem *nameItem = new QStandardItem(package.m_name);
    nameItem->setCheckable(true);
    nameItem->setEditable(false);
    nameItem->setEnabled(true);
    nameItem->setCheckState(package.m_installed ? Qt::Checked : Qt::Unchecked);

    super::appendRow(QList<QStandardItem *>()
                     << nameItem << new QStandardItem(package.m_version) << new QStandardItem(package.m_release)
                     << new QStandardItem(package.m_arch) << packageItem);
}

QVariant PackageModel::getEntity(int row)
{
    return itemFromIndex(index(row, structSize + 1))->data();
}

QVariant PackageModel::getEntity(const QModelIndex *index)
{
    return index->siblingAtColumn(structSize + 1).data();
}

void PackageModel::insertRow(int row, QVariant &entity)
{
    QStandardItem *packageItem = new QStandardItem();
    packageItem->setData(entity, Qt::DisplayRole);
    Package package = entity.value<Package>();
    super::insertRow(row,
                     QList<QStandardItem *>()
                         << new QStandardItem(package.m_name) << new QStandardItem(package.m_version)
                         << new QStandardItem(package.m_release) << new QStandardItem(package.m_arch)
                         << new QStandardItem(package.m_installed) << packageItem);
}
