#ifndef REPO_H
#define REPO_H

#include <QMetaType>
#include <QString>

struct Repo
{
    QString m_type{};
    QString m_branch{};
    QString m_url{};
    QString m_component{};
    QString m_full{};

    Repo()
        : m_type()
        , m_branch()
        , m_url()
        , m_component()
        , m_full()
    {}
    ~Repo() {}

    Repo(QString type, QString branch, QString url, QString component, QString full)
        : m_type(type)
        , m_branch(branch)
        , m_url(url)
        , m_component(component)
        , m_full(full)
    {}

    Repo(const Repo &repo)
        : m_type(repo.m_type)
        , m_branch(repo.m_branch)
        , m_url(repo.m_url)
        , m_component(repo.m_component)
        , m_full(repo.m_full)
    {}

    Repo &operator=(const Repo &package)
    {
        this->m_type      = package.m_type;
        this->m_branch    = package.m_branch;
        this->m_component = package.m_component;
        this->m_url       = package.m_url;
        this->m_full      = package.m_full;
        return *this;
    }

    void clear()
    {
        m_type.clear();
        m_branch.clear();
        m_url.clear();
        m_component.clear();
        m_full.clear();
    }
};

Q_DECLARE_METATYPE(Repo)

#endif // REPO_H
