#include "repobuttonwidget.h"
#include "ui_repobuttonwidget.h"

RepoButtonWidget::RepoButtonWidget(RepoController *controller, QWidget *parent)
    : QWidget(parent)
    , ui(new Ui::RepoButtonWidget)
    , m_controller(controller)
{
    ui->setupUi(this);
    connect(ui->removeButton, &QPushButton::clicked, this, &RepoButtonWidget::onRemoveButtonClicked);
    connect(ui->addButton, &QPushButton::clicked, this, &RepoButtonWidget::onAddButtonClicked);
}

RepoButtonWidget::~RepoButtonWidget()
{
    delete ui;
}

void RepoButtonWidget::disableButtons()
{
    ui->removeButton->setEnabled(false);
}

void RepoButtonWidget::enableButtons()
{
    ui->removeButton->setEnabled(true);
}

void RepoButtonWidget::onRemoveButtonClicked()
{
    m_controller->onRemoveButtonPressed();
}

void RepoButtonWidget::onAddButtonClicked()
{
    m_controller->onAddButtonPressed();
}
