#ifndef REPOBUTTONWIDGET_H
#define REPOBUTTONWIDGET_H

#include "repocontroller.h"

#include <QWidget>

namespace Ui
{
class RepoButtonWidget;
}

class RepoButtonWidget : public QWidget
{
    Q_OBJECT

public:
    explicit RepoButtonWidget(RepoController *controller, QWidget *parent = nullptr);
    ~RepoButtonWidget();

    RepoButtonWidget(const RepoButtonWidget &) = delete;
    RepoButtonWidget(RepoButtonWidget &&)      = delete;

    RepoButtonWidget &operator=(const RepoButtonWidget &) = delete;
    RepoButtonWidget &operator=(RepoButtonWidget &&) = delete;

    void disableButtons();
    void enableButtons();

private slots:
    void onRemoveButtonClicked();
    void onAddButtonClicked();

private:
    Ui::RepoButtonWidget *ui;

    RepoController *m_controller;
};

#endif // REPOBUTTONWIDGET_H
