#ifndef REPOCONTROLLER_H
#define REPOCONTROLLER_H

#include "basecontroller.h"
#include "repo.h"

class RepoControllerPrivate;

class RepoController : public BaseController
{
public:
    RepoController(DataSourceInterface *dataSource);
    ~RepoController();

    QString getInterface() override;
    QString getPath() override;

    void selected() override;
    void deSelected() override;

    void onWindowClose() override;

    void update() override;

    void onFilterTextChanged(const QString text) override;

    void onRemoveButtonPressed();
    void onAddButtonPressed();

    void onSelected(std::vector<Repo> repos);

private:
    void disableButtons();
    void enableButtons();

private:
    std::unique_ptr<RepoControllerPrivate> d;

public:
    RepoController(const RepoController &) = delete;
    RepoController(RepoController &&)      = delete;
    RepoController &operator=(const RepoController &) = delete;
    RepoController &operator=(RepoController &&) = delete;
};

#endif // REPOCONTROLLER_H
