#ifndef REPOCONTROLLERWIDGET_H
#define REPOCONTROLLERWIDGET_H

#include "ampproxymodel.h"
#include "repo.h"
#include "repocontroller.h"
#include "repomodel.h"

#include <QShortcut>
#include <QWidget>

namespace Ui
{
class RepoControllerWidget;
}

class RepoControllerWidget : public QWidget
{
    Q_OBJECT

public:
    explicit RepoControllerWidget(RepoController *controller, QWidget *parent = nullptr);
    ~RepoControllerWidget();

    RepoControllerWidget(const RepoControllerWidget &) = delete;
    RepoControllerWidget(RepoControllerWidget &&)      = delete;

    RepoControllerWidget &operator=(const RepoControllerWidget &) = delete;
    RepoControllerWidget &operator=(RepoControllerWidget &&) = delete;

    void setRepoList(const std::vector<Repo> &repos);

    void setFilter(const QString text);

private slots:
    void selected(const QItemSelection &selected, const QItemSelection &deselected);

private:
    Ui::RepoControllerWidget *ui;

    RepoController *m_controller;

    std::unique_ptr<RepoModel> model;
    std::unique_ptr<AMPProxyModel> proxyModel;

    QShortcut *addSc;
    QShortcut *rmSc;
    QShortcut *updateSc;
};

#endif // REPOCONTROLLERWIDGET_H
