#include "repomodel.h"

RepoModel::RepoModel(int rows, QObject *parent)
    : super(rows, structSize + 1, parent)
{}

void RepoModel::appendRow(const QVariant &entity)
{
    QStandardItem *repoItem = new QStandardItem();
    repoItem->setData(entity, Qt::DisplayRole);
    Repo repo = entity.value<Repo>();
    super::appendRow(QList<QStandardItem *>()
                     << new QStandardItem(repo.m_type) << new QStandardItem(repo.m_branch)
                     << new QStandardItem(repo.m_url) << new QStandardItem(repo.m_component) << repoItem);
}

QVariant RepoModel::getEntity(int row)
{
    return itemFromIndex(index(row, structSize + 1))->data();
}

QVariant RepoModel::getEntity(const QModelIndex *index)
{
    return index->siblingAtColumn(structSize + 1).data();
}

void RepoModel::insertRow(int row, QVariant &entity)
{
    QStandardItem *repoItem = new QStandardItem();
    repoItem->setData(entity, Qt::DisplayRole);
    Repo repo = entity.value<Repo>();
    super::insertRow(row,
                     QList<QStandardItem *>()
                         << new QStandardItem(repo.m_type) << new QStandardItem(repo.m_branch)
                         << new QStandardItem(repo.m_url) << new QStandardItem(repo.m_component) << repoItem);
}
