#include "rpmbuttonwidget.h"
#include "ui_rpmbuttonwidget.h"

RpmButtonWidget::RpmButtonWidget(RpmController *controller, QWidget *parent)
    : QWidget(parent)
    , ui(new Ui::RpmButtonWidget)
    , m_controller(controller)
{
    ui->setupUi(this);
    connect(ui->infoPushButton, &QPushButton::clicked, this, &RpmButtonWidget::onInfoButtonClicked);
    connect(ui->installPushButton, &QPushButton::clicked, this, &RpmButtonWidget::onInstallButtonClicked);
    connect(ui->removePushButton, &QPushButton::clicked, this, &RpmButtonWidget::onRemoveButtonClicked);
    connect(ui->filesPushButton, &QPushButton::clicked, this, &RpmButtonWidget::onFilesButtonClicked);
}

RpmButtonWidget::~RpmButtonWidget()
{
    delete ui;
}

void RpmButtonWidget::disableButtons()
{
    ui->filesPushButton->setEnabled(false);
    ui->removePushButton->setEnabled(false);
    ui->infoPushButton->setEnabled(false);
}

void RpmButtonWidget::enableButtons()
{
    ui->filesPushButton->setEnabled(true);
    ui->removePushButton->setEnabled(true);
    ui->infoPushButton->setEnabled(true);
}

void RpmButtonWidget::onRemoveButtonClicked()
{
    m_controller->onRemoveButtonPressed();
}

void RpmButtonWidget::onInstallButtonClicked()
{
    m_controller->onInstallButtonPressed();
}

void RpmButtonWidget::onInfoButtonClicked()
{
    m_controller->onInfoButtonPressed();
}

void RpmButtonWidget::onFilesButtonClicked()
{
    m_controller->onFilesButtonPressed();
}
