#ifndef RPMBUTTONWIDGET_H
#define RPMBUTTONWIDGET_H

#include "rpmcontroller.h"

#include <QWidget>

namespace Ui
{
class RpmButtonWidget;
}

class RpmButtonWidget : public QWidget
{
    Q_OBJECT

public:
    explicit RpmButtonWidget(RpmController *controller, QWidget *parent = nullptr);
    ~RpmButtonWidget();

    RpmButtonWidget(const RpmButtonWidget &) = delete;
    RpmButtonWidget(RpmButtonWidget &&)      = delete;

    RpmButtonWidget &operator=(const RpmButtonWidget &) = delete;
    RpmButtonWidget &operator=(RpmButtonWidget &&) = delete;

    void disableButtons();
    void enableButtons();

private slots:
    void onRemoveButtonClicked();
    void onInstallButtonClicked();
    void onInfoButtonClicked();
    void onFilesButtonClicked();

private:
    Ui::RpmButtonWidget *ui;

    RpmController *m_controller;
};

#endif // RPMBUTTONWIDGET_H
