#ifndef RPMCONTROLLER_H
#define RPMCONTROLLER_H

#include "basecontroller.h"
#include "package.h"

class RpmControllerPrivate;

class RpmController : public BaseController
{
public:
    RpmController(DataSourceInterface *dataSource);
    ~RpmController();

    QString getInterface() override;
    QString getPath() override;

    void selected() override;
    void deSelected() override;

    void onWindowClose() override;

    void update() override;

    void onFilterTextChanged(const QString text) override;

    void onRemoveButtonPressed();
    void onInstallButtonPressed();
    void onInfoButtonPressed();
    void onFilesButtonPressed();

    void onItemClicked(const Package &pkg);

private:
    void disableButtons();
    void enableButtons();

    void updateModelData();

private:
    std::unique_ptr<RpmControllerPrivate> d;

private:
    RpmController(const RpmController &) = delete;
    RpmController(RpmController &&)      = delete;
    RpmController &operator=(const RpmController &) = delete;
    RpmController &operator=(RpmController &&) = delete;
};

#endif // RPMCONTROLLER_H
