#ifndef RPMCONTROLLERWIDGET_H
#define RPMCONTROLLERWIDGET_H

#include "package.h"
#include "packagemodel.h"
#include "rpmcontroller.h"
#include "rpmproxymodel.h"

#include <memory>
#include <QWidget>

namespace Ui
{
class RpmControllerWidget;
}

class RpmControllerWidget : public QWidget
{
    Q_OBJECT

public:
    explicit RpmControllerWidget(RpmController *controller, QWidget *parent = nullptr);
    ~RpmControllerWidget();

    RpmControllerWidget(const RpmControllerWidget &) = delete;
    RpmControllerWidget(RpmControllerWidget &&)      = delete;

    RpmControllerWidget &operator=(const RpmControllerWidget &) = delete;
    RpmControllerWidget &operator=(RpmControllerWidget &&) = delete;

    void setPackagesList(const std::vector<Package> &packages);

    void setFilter(const QString text);

private slots:
    void itemClicked(const QModelIndex &index);

private:
    Ui::RpmControllerWidget *ui;

    RpmController *m_controller;

    std::unique_ptr<PackageModel> model;
    std::unique_ptr<AMPProxyModel> proxyModel;
};

#endif // RPMCONTROLLERWIDGET_H
