#include "rpminfodialog.h"
#include "ui_rpminfodialog.h"

#include <QRegularExpression>
#include <QStandardItemModel>

RpmInfoDialog::RpmInfoDialog(QWidget *parent)
    : QDialog(parent)
    , ui(new Ui::RpmInfoDialog)
{
    ui->setupUi(this);
}

RpmInfoDialog::~RpmInfoDialog()
{
    delete ui;
}

void RpmInfoDialog::setInfoText(QString info)
{
    auto model             = new QStandardItemModel();
    auto descriptionRegexp = QRegularExpression("^((?:.+\\: .+\\n)*)(.+\\:\\n[\\s\\S]+)$");
    auto keyValueRegexp    = QRegularExpression("(.+)\\: (.+)\\n");

    auto descriptionBlockMatch = descriptionRegexp.match(info);
    if (!descriptionBlockMatch.hasMatch())
    {
        return;
    }

    auto keyValueIter = keyValueRegexp.globalMatch(descriptionBlockMatch.captured(1));
    while (keyValueIter.hasNext())
    {
        auto rowMatch = keyValueIter.next();
        model->appendRow(QList<QStandardItem *>()
                         << new QStandardItem(rowMatch.captured(1)) << new QStandardItem(rowMatch.captured(2)));
    }
    auto description = descriptionBlockMatch.captured(2);
    auto t1          = description.section("\n", 0, 0);
    auto t2          = description.section("\n", 1, -1);
    model->appendRow(QList<QStandardItem *>() << new QStandardItem(description.section("\n", 0, 0))
                                              << new QStandardItem(description.section("\n", 1, -1)));
    ui->infoView->setModel(model);
    ui->infoView->resizeColumnsToContents();
    ui->infoView->resizeRowsToContents();
}
