#ifndef DATASOURCEINTERFACE_H
#define DATASOURCEINTERFACE_H

#include <optional>
#include <QDBusReply>
#include <QObject>
#include <QString>
#include <QStringList>

class DataSourceInterface
{
public:
    virtual ~DataSourceInterface() = default;

    virtual QStringList getObjectsPathsByIface(QString iface) = 0;

    virtual std::optional<QStringList> rpmList()                       = 0;
    virtual std::optional<int> rpmInstall(const QString package)       = 0;
    virtual std::optional<int> rpmRemove(const QString package)        = 0;
    virtual std::optional<QString> rpmInfo(const QString package)      = 0;
    virtual std::optional<QStringList> rpmFiles(const QString package) = 0;

    virtual std::optional<int> aptInstall(const QString package)     = 0;
    virtual std::optional<int> aptReinstall(const QString package)   = 0;
    virtual std::optional<int> aptRemove(const QString package)      = 0;
    virtual std::optional<int> aptUpdate()                           = 0;
    virtual std::optional<std::vector<QString>> aptListAllPackages() = 0;
    virtual std::optional<QString> aptLastUpdate()                   = 0;

    virtual std::optional<int> repoAdd(const QString repo)    = 0;
    virtual std::optional<QStringList> repoList()             = 0;
    virtual std::optional<int> repoRemove(const QString repo) = 0;

signals:
    virtual void aptUpdateFinished(QDBusPendingCallWatcher *call) = 0;
};

Q_DECLARE_INTERFACE(DataSourceInterface, "DataSourceInterface")

#endif //DATASOURCEINTERFACE_H
