#ifndef MAINWINDOWINTERFACE_H
#define MAINWINDOWINTERFACE_H

#include "controllers/controllerinterface.h"

#include <QAbstractItemModel>

class ControllerInterface;

class MainWindowInterface
{
public:
    virtual ~MainWindowInterface() = default;

    virtual void setController(ControllerInterface *controller) = 0;
    virtual ControllerInterface *getController()                = 0;

    virtual void setModel(QAbstractItemModel *model) = 0;
    virtual void selectInterface(QString iface)      = 0;

    virtual void setButtonWidget(QWidget *widget)     = 0;
    virtual void setControllerWidget(QWidget *widget) = 0;

    virtual void closeFromButtonWidget() = 0;

    virtual void setSearchText(const QString text) = 0;
};

#endif // MAINWINDOWINTERFACE_H
