#ifndef PACKAGESWIDGET_H
#define PACKAGESWIDGET_H

#include <QAbstractItemModel>
#include <QItemSelectionModel>
#include <QShortcut>
#include <QWidget>

namespace Ui
{
class PackagesWidget;
}

class PackagesWidget : public QWidget
{
    Q_OBJECT

public:
    explicit PackagesWidget(QWidget *parent = nullptr);
    ~PackagesWidget();

    void setModel(QAbstractItemModel *model);

    void setButtonWidget(QWidget *widget);
    void setControllerWidget(QWidget *widget);
    void setIndex(QModelIndex index);

    void setSearchText(const QString text);

private:
    void clearLayout(QLayout *layout);

signals:
    void selectionChanged(const QItemSelection &newSelection, const QItemSelection &previousSelection);
    void filterTextChanged(const QString text);

private slots:
    void onSelectionChanged(const QItemSelection &newSelection, const QItemSelection &previousSelection);
    void onFilterTextChanged();

private:
    Ui::PackagesWidget *ui;

    QShortcut *findShortcut{nullptr};

public:
    PackagesWidget(const PackagesWidget &) = delete;
    PackagesWidget(PackagesWidget &&)      = delete;
    PackagesWidget &operator=(const PackagesWidget &) = delete;
    PackagesWidget &operator=(PackagesWidget &&) = delete;
};

#endif // PACKAGESWIDGET_H
